Index: java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 84)
@@ -6,4 +6,7 @@
 import com.framsticks.core.Instance;
 import com.framsticks.util.*;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 import org.apache.log4j.Logger;
 
@@ -18,71 +21,71 @@
 public class LoadStream {
 
-    private final static Logger LOGGER = Logger.getLogger(LoadStream.class.getName());
+	private final static Logger log = Logger.getLogger(LoadStream.class.getName());
 
-    protected final Instance instance;
-    protected final Path mountPath;
-    protected final BufferedReader stream;
-    protected final Future<Path> future;
-    protected final Stopwatch stopwatch = new Stopwatch();
+	protected final Instance instance;
+	protected final Path mountPath;
+	protected final BufferedReader stream;
+	protected final Future<Path> future;
+	protected final Stopwatch stopwatch = new Stopwatch();
 
 
-    public LoadStream(Path mountPath, BufferedReader stream, Instance instance, Future<Path> future) {
-        this.instance = instance;
-        this.mountPath = mountPath;
-        this.stream = stream;
-        this.future = future;
-    }
+	public LoadStream(Path mountPath, BufferedReader stream, Instance instance, Future<Path> future) {
+		this.instance = instance;
+		this.mountPath = mountPath;
+		this.stream = stream;
+		this.future = future;
+	}
 
-    public void load() {
-        try {
-            String line;
-            Pair<String, String> query = null;
-            List<File> files = null;
-            List<String> content = null;
-            //File file;
-            while ((line = stream.readLine()) != null) {
-                if (query == null) {
-                    query = Strings.splitIntoPair(line, ' ', "\n");
-                    files = new LinkedList<File>();
-                    LOGGER.trace("loading " + line);
-                    continue;
-                }
-                if (content == null) {
-                    if (line.equals("file")) {
-                        content = new LinkedList<String>();
-                        continue;
-                    }
-                    if (line.equals("ok")) {
-                        if (query.first.equals("get")) {
-                            Path path = instance.createIfNeeded(query.second);
-                            instance.processFetchedValues(path, files);
-                        } else if (query.first.equals("info")) {
-                            assert files.size() == 1;
-                            instance.processFetchedInfo(files.get(0));
-                        } else {
-                            assert false;
-                        }
-                        query = null;
-                        files = null;
-                        continue;
-                    }
-                    assert false;
-                    continue;
-                }
-                if (line.equals("eof")) {
-                    files.add(new File(query.second, new ListSource(content)));
-                    content = null;
-                    continue;
-                }
-                content.add(line);
-            }
-        } catch (IOException e) {
-            LOGGER.error("failed to load: " + e);
-            future.result(null, e);
-            return;
-        }
-        LOGGER.info("loaded in: " + stopwatch);
-        future.result(new Path(instance, mountPath.getTextual()), null);
-    }
+	public void load() {
+		try {
+			String line;
+			Pair<String, String> query = null;
+			List<File> files = null;
+			List<String> content = null;
+			//File file;
+			while ((line = stream.readLine()) != null) {
+				if (query == null) {
+					query = Strings.splitIntoPair(line, ' ', "\n");
+					files = new LinkedList<File>();
+					log.trace("loading " + line);
+					continue;
+				}
+				if (content == null) {
+					if (line.equals("file")) {
+						content = new LinkedList<String>();
+						continue;
+					}
+					if (line.equals("ok")) {
+						if (query.first.equals("get")) {
+							Path path = instance.createIfNeeded(query.second);
+							instance.processFetchedValues(path, files);
+						} else if (query.first.equals("info")) {
+							assert files.size() == 1;
+							instance.processFetchedInfo(files.get(0));
+						} else {
+							assert false;
+						}
+						query = null;
+						files = null;
+						continue;
+					}
+					assert false;
+					continue;
+				}
+				if (line.equals("eof")) {
+					files.add(new File(query.second, new ListSource(content)));
+					content = null;
+					continue;
+				}
+				content.add(line);
+			}
+		} catch (IOException e) {
+			log.error("failed to load: " + e);
+			future.result(null, e);
+			return;
+		}
+		log.info("loaded in: " + stopwatch);
+		future.result(instance.getPath(mountPath.getTextual()), null);
+	}
 
 
Index: java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/dumping/PrintWriterSink.java	(revision 84)
@@ -0,0 +1,38 @@
+package com.framsticks.dumping;
+
+import com.framsticks.params.SinkInterface;
+
+import java.io.PrintWriter;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class PrintWriterSink implements SinkInterface {
+
+    protected final PrintWriter stream;
+
+    public PrintWriterSink(PrintWriter stream) {
+        this.stream = stream;
+    }
+
+    @Override
+    public PrintWriterSink print(String str) {
+        stream.print(str);
+        return this;
+    }
+
+    @Override
+    public PrintWriterSink print(Object obj) {
+        stream.print(obj);
+        return this;
+    }
+
+    @Override
+    public void breakLine() {
+        stream.print('\n');
+    }
+
+    @Override
+    public void close() {
+    }
+}
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 84)
@@ -4,16 +4,17 @@
 import com.framsticks.core.Path;
 import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListAccess;
-import com.framsticks.params.Param;
-import com.framsticks.params.types.CompositeParam;
 import com.framsticks.params.SinkInterface;
 import com.framsticks.parsers.Savers;
 import com.framsticks.core.Instance;
 import com.framsticks.util.*;
+import com.framsticks.util.dispatching.Dispatching;
 import org.apache.log4j.Logger;
 
 import java.util.HashSet;
 import java.util.Set;
+import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 /**
@@ -22,21 +23,21 @@
 public class SaveStream {
 
-    private final static Logger LOGGER = Logger.getLogger(SaveStream.class.getName());
+	private final static Logger log = Logger.getLogger(SaveStream.class.getName());
 
-    protected final SinkInterface sink;
-    protected final Instance instance;
-    protected final StateFunctor stateFunctor;
-    protected final Stopwatch stopwatch = new Stopwatch();
-    protected final Set<FramsClass> storedInfo = new HashSet<FramsClass>();
+	protected final SinkInterface sink;
+	protected final Instance instance;
+	protected final StateFunctor stateFunctor;
+	protected final Stopwatch stopwatch = new Stopwatch();
+	protected final Set<FramsClass> storedInfo = new HashSet<FramsClass>();
 
-    private int dispatched = 0;
+	private int dispatched = 0;
 
-    public SaveStream(SinkInterface sink, Instance instance, Path root, StateFunctor stateFunctor) {
-        assert Dispatching.isThreadSafe();
-        this.sink = sink;
-        this.instance = instance;
-        this.stateFunctor = stateFunctor;
+	public SaveStream(SinkInterface sink, Instance instance, Path root, StateFunctor stateFunctor) {
+		assert Dispatching.isThreadSafe();
+		this.sink = sink;
+		this.instance = instance;
+		this.stateFunctor = stateFunctor;
 		dispatchWrite(root);
-    }
+	}
 
 	protected void dispatchWrite(final Path path) {
@@ -50,49 +51,46 @@
 	}
 
-    protected void finished() {
-        assert instance.isActive();
-        LOGGER.info("stored in " + stopwatch);
-        stateFunctor.call(null);
-    }
+	protected void finished() {
+		assert instance.isActive();
+		log.info("stored in " + stopwatch);
+		stateFunctor.call(null);
+	}
 
-    public void write(final Path path) {
-        assert instance.isActive();
-        if (!path.isResolved()) {
-            LOGGER.debug("path " + path + " is not resolved - skipping");
-        } else {
-            AccessInterface access = instance.bindAccess(path);
+	public void write(final Path path) {
+		assert instance.isActive();
+		if (!path.isResolved()) {
+			log.debug("path " + path + " is not resolved - skipping");
+		} else {
+			AccessInterface access = instance.bindAccess(path);
 			assert access != null;
-            FramsClass framsClass = access.getFramsClass();
-            assert framsClass != null;
-            if (!storedInfo.contains(framsClass)) {
-                storedInfo.add(framsClass);
-                sink.print("info ").print(path.getTextual()).breakLine();
-                sink.print("file").breakLine();
-                Savers.saveFramsClass(sink, framsClass);
-                sink.print("eof").breakLine();
-                sink.print("ok").breakLine();
-            }
-            if (!(access instanceof ListAccess)) {
-                sink.print("get ").print(path.getTextual()).breakLine();
-                sink.print("file").breakLine();
-                //stream.print("#" + access.getSelected().getClass().getCanonicalName() + "\n");
-                access.save(sink);
-                sink.print("eof").breakLine();
-                sink.print("ok").breakLine();
-            }
-            for (Param p : access.getParams()) {
-                if (p instanceof CompositeParam) {
-                    CompositeParam childParam = (CompositeParam)p;
-                    final Path childPath = path.appendNode(new Node(childParam, access.get(childParam, Object.class)));
-                    if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
-						dispatchWrite(childPath);
-                    }
-                }
-            }
-        }
-        --dispatched;
-        if (dispatched == 0) {
-            finished();
-        }
-    }
+			FramsClass framsClass = access.getFramsClass();
+			assert framsClass != null;
+			if (!storedInfo.contains(framsClass)) {
+				storedInfo.add(framsClass);
+				sink.print("info ").print(path.getTextual()).breakLine();
+				sink.print("file").breakLine();
+				Savers.saveFramsClass(sink, framsClass);
+				sink.print("eof").breakLine();
+				sink.print("ok").breakLine();
+			}
+			if (!(access instanceof ListAccess)) {
+				sink.print("get ").print(path.getTextual()).breakLine();
+				sink.print("file").breakLine();
+				//stream.print("#" + access.getSelected().getClass().getCanonicalName() + "\n");
+				access.save(sink);
+				sink.print("eof").breakLine();
+				sink.print("ok").breakLine();
+			}
+			for (CompositeParam p : filterInstanceof(access.getParams(), CompositeParam.class)) {
+				final Path childPath = path.appendNode(new Node(p, access.get(p, Object.class)));
+				if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
+					dispatchWrite(childPath);
+				}
+			}
+		}
+		--dispatched;
+		if (dispatched == 0) {
+			finished();
+		}
+	}
 }
Index: java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java
===================================================================
--- java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 84)
@@ -3,14 +3,17 @@
 import com.framsticks.core.Instance;
 import com.framsticks.core.Node;
-import com.framsticks.core.Parameters;
-import com.framsticks.core.Path;
+import com.framsticks.dumping.PrintWriterSink;
 import com.framsticks.model.*;
 import com.framsticks.model.Package;
 import com.framsticks.params.*;
-import com.framsticks.params.types.CompositeParam;
 import com.framsticks.parsers.F0Parser;
+import com.framsticks.parsers.F0Writer;
 import com.framsticks.parsers.Schema;
+
+import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
+import java.io.PrintWriter;
+import java.io.StringWriter;
 import java.util.List;
 
@@ -20,17 +23,20 @@
 public class GenotypeBrowser extends Instance {
 
-	private static final Logger LOGGER = Logger.getLogger(Instance.class.getName());
+	private static final Logger log = Logger
+			.getLogger(Instance.class.getName());
 	protected Schema schema;
 
-
-	public GenotypeBrowser(Parameters parameters) {
-		super(parameters);
-		LOGGER.info("model builder created");
+	public GenotypeBrowser() {
+		log.info("model builder created");
 	}
 
 	@Override
-	protected void configure() throws Exception {
-		super.configure();
-		schema = new Schema(Schema.getDefaultDefinitionAsStream());
+	public void configure(Configuration config) {
+		super.configure(config);
+		try {
+			schema = new Schema(Schema.getDefaultDefinitionAsStream());
+		} catch (Exception e) {
+			log.error("failed to load schema: " + e);
+		}
 		this.registry = schema.getRegistry();
 		Package.register(this.getRegistry());
@@ -38,4 +44,5 @@
 		registry.putInfoIntoCache(new FramsClass("ModelBuilderRoot", "ModelBuilderRoot", null)
 				.append(new ParamBuilder().setType("o Model").setId("model").setName("model").build())
+				.append(new ParamBuilder().setType("s 1").setId("genotype").setName("genotype").build())
 		);
 		root = new Node((CompositeParam)new ParamBuilder().setType("o ModelBuilderRoot").setId(name).setName("Instance").build(), PropertiesAccess.createPropertiesMap());
@@ -51,10 +58,14 @@
 			Model model = Model.build(objects);
 
-			AccessInterface rootAccess = bindAccess(new Path(this, "/"));
+			AccessInterface rootAccess = bindAccess(this.getRootPath());
 
 			rootAccess.set("model", model);
 
+			StringWriter w = new StringWriter();
+			new F0Writer(schema, model, new PrintWriterSink(new PrintWriter(w))).write();
+			rootAccess.set("genotype", w.getBuffer().toString());
+
 		} catch (Exception e) {
-			LOGGER.error("exception caught: " + e);
+			log.error("exception caught: " + e);
 		}
 		//done();
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 84)
@@ -4,9 +4,18 @@
 import com.framsticks.observers.Endpoint;
 import com.framsticks.observers.Observer;
-import com.framsticks.util.Dispatcher;
+import com.framsticks.util.Logging;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Future;
+
+import org.apache.commons.configuration.Configuration;
+import org.apache.commons.lang.ArrayUtils;
 import org.apache.log4j.Logger;
 
 import javax.swing.*;
+
+import java.awt.Dimension;
+import java.util.ArrayList;
 import java.util.HashSet;
+import java.util.List;
 import java.util.Set;
 
@@ -16,110 +25,188 @@
 public class Browser extends Observer implements Dispatcher {
 
-    private static final Logger LOGGER = Logger.getLogger(Browser.class.getName());
-
-    protected final Set<Frame> frames = new HashSet<Frame>();
-    protected MainFrame mainFrame;
-
-    public void addFrame(Frame frame) {
-        frames.add(frame);
-    }
-
-	public Browser(Parameters parameters) {
-        super(parameters);
-        dispatcher = SwingDispatcher.instance;
-        invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                assert isActive();
-
-            }
-        });
+	private static final Logger log = Logger.getLogger(Browser.class.getName());
+
+	protected final Set<Frame> frames = new HashSet<Frame>();
+	protected MainFrame mainFrame;
+	public List<PanelProvider> panelProviders = new ArrayList<PanelProvider>();
+	protected Dimension defaultFrameDimension;
+
+	public void addFrame(Frame frame) {
+		frames.add(frame);
+	}
+
+	public Browser() {
+		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
+		addPanelProvider(new StandardPanelProvider());
+	}
+
+	@Override
+	public void configure(Configuration config) {
+		super.configure(config);
+
+		defaultFrameDimension = new Dimension(config.getInteger("size.width", 1000), config.getInteger("size.height", 500));
+
+		for (String name : config.getStringArray("panel_providers")) {
+			try {
+				Class<?> c = Class.forName(name);
+				if (ArrayUtils.indexOf(c.getInterfaces(), PanelProvider.class) == -1) {
+					continue;
+				}
+				PanelProvider p = (PanelProvider)c.newInstance();
+				addPanelProvider(p);
+			} catch (Exception e) {
+				log.error("failed to load PanelProvider " + name + ": " + e);
+			}
+		}
+
+		// for (final String path : config.getStringArray("resolve_paths")) {
+		//	invokeLater()
+		//	autoResolvePath(path, new Future<Path>() {
+		//		@Override
+		//		public void result(Path p, Exception e) {
+		//			Logging.log(log, "auto resolve path", path, e);
+		//		}
+		//	});
+		// }
+	}
+
+	public void addPanelProvider(PanelProvider panelProvider) {
+		log.debug("added panel provider of type: " + panelProvider.getClass().getCanonicalName());
+		panelProviders.add(panelProvider);
+	}
+
+	public void autoResolvePath(final String path, final Future<Path> future) {
+		final Instance i = endpoints.get("localhost").getInstance();
+		i.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				i.resolveAndFetch(path, new Future<Path>() {
+					@Override
+					public void result(final Path p, Exception e) {
+						Logging.log(log, "auto resolve path", path, e);
+						if (future != null) {
+							future.result(p, e);
+						}
+						if (e == null) {
+							mainFrame.invokeLater(new Runnable() {
+								@Override
+								public void run() {
+									mainFrame.goTo(p);
+								}
+							});
+						}
+					}
+				});
+			}
+		});
 	}
 
 	public void clear() {
-        assert isActive();
-        for (Frame f : frames) {
-            f.clear();
-        }
-	}
-
-    @Override
-    protected void configure() throws Exception {
-        super.configure();
-    }
-
-
-    @Override
-    public void run() {
-        super.run();
-
-        try {
-            UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
-        } catch (Exception ex) {
-            LOGGER.warn("failed loading Look&Feel: ", ex);
-        }
-        javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
-
-        mainFrame = new MainFrame(Browser.this);
-        addFrame(mainFrame);
-
-        for (Frame f : frames) {
-            f.configure();
-        }
-
-        for (final Endpoint e : getEndpoints().values()) {
-            e.invokeLater(new Runnable() {
-                @Override
-                public void run() {
-                    final Path p = new Path(e.getInstance(), "/");
-                    invokeLater(new Runnable() {
-                        @Override
-                        public void run() {
-                            mainFrame.addRootPath((BrowserEndpoint) e, p);
-                        }
-                    });
-                }
-            });
-
-        }
-
-        for (Frame f : frames) {
-            f.setVisible(true);
-        }
-    }
-
-    public void createTreeNodeForChild(final Path path) {
-        assert !isActive();
-        //assert instance.isActive();
+		assert isActive();
+		for (Frame f : frames) {
+			f.clear();
+		}
+	}
+
+	@Override
+	public void run() {
+		super.run();
+
+		assert isActive();
+
+		try {
+			boolean found = false;
+			// for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
+			//	log.info("look and feel available: " + info.getName());
+			//	if ("Nimbus".equals(info.getName())) {
+			//		UIManager.setLookAndFeel(info.getClassName());
+			//		found = true;
+			//		break;
+			//	}
+			// }
+			if (!found) {
+				UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
+			}
+		} catch (Exception ex) {
+			log.warn("failed loading Look&Feel: ", ex);
+		}
+
+		javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
+
+		mainFrame = new MainFrame(Browser.this);
+		addFrame(mainFrame);
+
+		for (Frame f : frames) {
+			f.configure();
+		}
+
+		for (final Endpoint e : getEndpoints().values()) {
+			e.invokeLater(new Runnable() {
+				@Override
+				public void run() {
+					final Path p = e.getInstance().getRootPath();
+					invokeLater(new Runnable() {
+						@Override
+						public void run() {
+							mainFrame.addRootPath((BrowserEndpoint) e, p);
+						}
+					});
+				}
+			});
+		}
+
+		for (Frame f : frames) {
+			f.setVisible(true);
+		}
+
+		// autoResolvePath("/simulator/genepools/groups/0", null);
+		// autoResolvePath("/", null);
+	}
+
+	public void createTreeNodeForChild(final Path path) {
+		assert !isActive();
+		//assert instance.isActive();
 
 
 /*
-        final TreeNode parentTreeNode = (TreeNode) child.getParent().getUserObject();
-        if (parentTreeNode == null) {
-            Dispatching.invokeDispatch(this, manager, new Runnable() {
-                @Override
-                public void run() {
-                    createTreeNodeForChild(child);
-                }
-            });
-            return;
-        }
-        LOGGER.debug(child.getClass().getSimpleName() + " created: " + child);
-
-
-        invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                parentTreeNode.getOrCreateChildTreeNodeFor(child);
-            }
-        });
+		final TreeNode parentTreeNode = (TreeNode) child.getParent().getUserObject();
+		if (parentTreeNode == null) {
+			Dispatching.invokeDispatch(this, manager, new Runnable() {
+				@Override
+				public void run() {
+					createTreeNodeForChild(child);
+				}
+			});
+			return;
+		}
+		log.debug(child.getClass().getSimpleName() + " created: " + child);
+
+
+		invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				parentTreeNode.getOrCreateChildTreeNodeFor(child);
+			}
+		});
 */
 	}
 
 
-    @Override
-    protected Endpoint createEndpoint() {
-        return new BrowserEndpoint();
-    }
+	@Override
+	protected Endpoint createEndpoint() {
+		return new BrowserEndpoint();
+	}
+
+	@Override
+	public Dispatcher createDefaultDispatcher() {
+		return SwingDispatcher.instance;
+	}
+
+	/**
+	 * @return the mainFrame
+	 */
+	public MainFrame getMainFrame() {
+		return mainFrame;
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/gui/EmptyPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/EmptyPanel.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/EmptyPanel.java	(revision 84)
@@ -0,0 +1,23 @@
+package com.framsticks.gui;
+
+import com.framsticks.params.AccessInterface;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@SuppressWarnings("serial")
+public class EmptyPanel extends Panel {
+
+	public EmptyPanel(Parameters parameters) {
+		super(parameters);
+	}
+
+	@Override
+	public void pullValuesFromLocalToUser(AccessInterface access) {
+	}
+
+	@Override
+	public String getTitle() {
+		return "Empty";
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 84)
@@ -1,42 +1,176 @@
 package com.framsticks.gui;
 
-import java.util.HashMap;
-import java.util.Map;
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Instance;
+import com.framsticks.core.InstanceListener;
+import com.framsticks.core.ListChange;
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+
+import java.util.*;
+
+import javax.swing.tree.TreePath;
 
 /**
  * @author Piotr Sniegowski
  */
-public class EndpointAtFrame {
-    protected final BrowserEndpoint endpoint;
-    protected final Frame frame;
-    protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
+public class EndpointAtFrame implements InstanceListener {
 
-    public EndpointAtFrame(BrowserEndpoint endpoint, Frame frame) {
-        this.endpoint = endpoint;
-        this.frame = frame;
-    }
+	private static final Logger log = Logger.getLogger(EndpointAtFrame.class);
 
+	protected final BrowserEndpoint endpoint;
+	protected final Frame frame;
+	protected final Instance instance;
+	protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
+	protected TreeNode rootTreeNode;
 
-    public BrowserEndpoint getEndpoint() {
-        return endpoint;
-    }
+	public EndpointAtFrame(BrowserEndpoint endpoint, Frame frame) {
+		this.endpoint = endpoint;
+		this.frame = frame;
+		this.instance = endpoint.getInstance();
+	}
 
-    public Frame getFrame() {
-        return frame;
-    }
+	public BrowserEndpoint getEndpoint() {
+		return endpoint;
+	}
 
-    public void registerPanel(Panel panel) {
-        assert frame.isActive();
-        knownPanels.put(panel.getClassName(), panel);
-        frame.cardPanel.add(panel, panel.getFullName());
-    }
+	public Frame getFrame() {
+		return frame;
+	}
 
-    public Panel findPanel(String className) {
-        assert frame.isActive();
-        return (knownPanels.containsKey(className) ? knownPanels.get(className) : null);
-    }
+	public void registerPanel(Panel panel) {
+	}
 
-    public final String getName() {
-        return endpoint.getName();
-    }
+	public Panel findPanel(String accessId) {
+		assert frame.isActive();
+		return (knownPanels.containsKey(accessId) ? knownPanels.get(accessId) : null);
+	}
+
+	public final String getName() {
+		return endpoint.getName();
+	}
+
+	public Panel preparePanel(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		Panel panel = preparePanelImpl(param, framsClass);
+		assert panel != null;
+		String accessId = param.computeAccessId();
+		panel.uniqueName = accessId + "@" + endpoint.getName();
+		knownPanels.put(accessId, panel);
+		frame.cardPanel.add(panel, panel.uniqueName);
+		log.debug("prepared panel for " + panel);
+		return panel;
+	}
+
+	protected Panel preparePanelImpl(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		List<Panel> panels = new ArrayList<Panel>();
+
+		Panel.Parameters parameters = new Panel.Parameters(this, param,
+				framsClass);
+		for (PanelProvider pp : frame.browser.panelProviders) {
+			Panel p = pp.providePanel(parameters);
+			if (p != null) {
+				panels.add(p);
+			}
+		}
+
+		if (panels.isEmpty()) {
+			return new EmptyPanel(parameters);
+		}
+		if (panels.size() == 1) {
+			return panels.get(0);
+		}
+		return new MultiPanel(parameters, panels);
+
+	}
+
+	@Override
+	public void onListChange(Path path, ListChange change) {
+
+	}
+
+	public TreePath getTreePath(Path path, boolean create) {
+		assert frame.isActive();
+		TreeNode t = rootTreeNode;
+		TreePath result = new TreePath(frame.rootNode).pathByAddingChild(rootTreeNode);
+		List<Node> nodes = path.getNodes();
+		Iterator<Node> i = nodes.iterator();
+		i.next();
+		// Node first = i.next();
+
+		// if (!t.path.isResolved()) {
+		// 	t.path = new Path(path.getInstance(), nodes, first);
+		// }
+		while (i.hasNext()) {
+			Node n = i.next();
+			TreeNode r = null;
+			for (TreeNode c : t.childrenIterable()) {
+				if (c.paramId.equals(n.getParam().getId())) {
+					r = c;
+					break;
+				}
+			}
+			if (r == null) {
+				log.debug("missing " + n.getParam().getId() + " in " + t);
+				if (!create) {
+					return result;
+				}
+				Path p = new Path(path.getInstance(), nodes, n);
+				log.debug("forced resolution: creating treenode for " + p);
+				TreeNode childNode = new TreeNode(EndpointAtFrame.this, p);
+
+				frame.addNode(childNode, t);
+				// frame.treeModel.reload();
+				// t.add(childNode);
+				// frame.treeModel.nodeStructureChanged(t);
+
+				r = childNode;
+			} else {
+				// if (!r.path.isResolved()) {
+				// 	r.path = new Path(path.getInstance(), nodes, n);
+				// }
+			}
+			result = result.pathByAddingChild(r);
+			t = r;
+		}
+		return result;
+	}
+
+	@Override
+	public void onFetch(final Path path) {
+		assert instance.isActive();
+		log.trace("fetched " + path);
+
+		frame.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+
+				TreePath treePath = getTreePath(path, true);
+				assert treePath.getPathCount() == path.size() + 1;
+
+				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
+				// log.trace("found " + result + " == " + path);
+				instance.invokeLater(new Runnable() {
+					@Override
+					public void run() {
+						result.reactForFetchResult(path, null);
+					}
+				});
+			}
+		});
+	}
+
+	@Override
+	public void onRun(Exception e) {
+
+	}
+
+	@Override
+	public void onStop(Exception e) {
+
+	}
 }
